#!/usr/bin/python3
#-*- coding: utf-8 -*-

import gi
gi.require_version('Gtk', '3.0')
from gi.repository import Gtk
import notify2
import os
import pwd
import urllib3

msgtitle = "Gesuser: mensaje para el grupo "
serverurl = 'http://c0/gesuser/mensajes/'


def show_message_dialog_slim():
	md = Gtk.MessageDialog(Gtk.Window(), Gtk.DialogFlags.MODAL, Gtk.MessageType.INFO, Gtk.ButtonsType.OK, title)
	md.format_secondary_text(msg)
	mdicon = Gtk.Image()
	mdicon.set_from_file("/usr/share/pyshared/cga-mensajeria-gesuser/icons/icon.svg")
	md.set_image(mdicon)
	md.show_all()
	md.connect("response", closed_slim)
	md.run()


def show_message_dialog_cb(n, action):
	if len(msg) > 150 or msg.count('\n') > 6:
		md = Gtk.MessageDialog(Gtk.Window(), Gtk.DialogFlags.MODAL, Gtk.MessageType.INFO, Gtk.ButtonsType.OK, title)
		md.format_secondary_text(msg)
		mdicon = Gtk.Image()
		mdicon.set_from_file("/usr/share/pyshared/cga-mensajeria-gesuser/icons/icon.svg")
		md.set_image(mdicon)
		md.show_all()
		md.run()
	n.close()
	
def closed_slim(n, *args):
	n.hide()
	n.destroy()

def closed_cb(n):
	Gtk.main_quit()

if __name__ == '__main__':
	gid = pwd.getpwuid(os.getuid()).pw_gid

	if gid == 10000:
		title = msgtitle + "Alumnos"
		url = serverurl + "mensaje-alumno.txt"
	elif gid  == 10001:
		title = msgtitle + "Profesores"
		url = serverurl + "mensaje-profesor.txt"
	elif gid == 10002:
		title = msgtitle + "Gestión"
		url = serverurl + "mensaje-gestion.txt"
	else:
		title = "Gesuser: mensaje general"
		url = serverurl + "mensaje.txt"

	http = urllib3.PoolManager()
	response = http.request('GET', url)
	if response.status == 200:
		notify2.init("Mensajeria Gesuser", mainloop='glib')
		filemessage = response.data.decode('utf-8')
		msg = '\n'.join(filemessage.split('\n')[1:-1])
		msg = msg.replace('\\n', '\n')
		caps = notify2.get_server_caps()
		if caps and 'actions' in caps:
			n = notify2.Notification(title, msg, "/usr/share/pyshared/cga-mensajeria-gesuser/icons/icon.svg")
			n.set_urgency(2)
			n.add_action("default", "Leer más", show_message_dialog_cb)
			n.connect('closed', closed_cb)
			n.show()
			Gtk.main()
		else:
			show_message_dialog_slim()
